unit FrmSplashScreen;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpeg, ExtCtrls, StdCtrls, MMSystem;

type
  TSplashScreen = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
  public
    procedure playsound(afile: string;synchrone:boolean);
  end;

var
  SplashScreen: TSplashScreen;

implementation

{$R *.dfm}

procedure TSplashScreen.FormCreate(Sender: TObject);
begin
  Image1.Picture.LoadFromFile(extractfilepath(application.exename)+'images\Jean_racine4.JPG');
end;

procedure TSplashScreen.playsound(afile: string;synchrone:boolean);
begin
  afile:=extractfilepath(application.exename)+'\audio\'+afile;
  if fileexists(afile) then
    if not synchrone then
      sndPlaySound(Pchar(afile),SND_NODEFAULT  Or SND_ASYNC)
    else
      sndPlaySound(Pchar(afile),SND_NODEFAULT  Or SND_SYNC); //SND_NOSTOP    SND_NODEFAULT
end;

end.
