unit Interfacepas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls,Contnrs, StdCtrls,PionManager, Menus, Grids,FrmSplashScreen,
  MMSystem;

type
  TFrmRacine4 = class(TForm)
    ImagePlateau: TImage;
    PopupMenu1: TPopupMenu;
    Sortir: TMenuItem;
    aimantbas: TImage;
    aimantgauche: TImage;
    aimanthaut: TImage;
    aimantdroit: TImage;
    Plateau: TStringGrid;
    Recommencer: TMenuItem;
    Aimanthaut1: TMenuItem;
    Aimantgauche1: TMenuItem;
    Aimantbas1: TMenuItem;
    Aimantdroit1: TMenuItem;
    Modedejeu1: TMenuItem;
    Mode1: TMenuItem;
    Mode2: TMenuItem;
    Ajouterpionbi: TMenuItem;
    LbCountrouge: TLabel;
    LbCountJaune: TLabel;
    Timer1: TTimer;
    Lbgauche: TLabel;
    Lbhaut: TLabel;
    Lbdroit: TLabel;
    Lbbas: TLabel;
    Tornade1: TMenuItem;
    Signal3pionsaligns: TMenuItem;
    Enregisterlapartie1: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Chargerunepartie1: TMenuItem;
    procedure Chargerunepartie1Click(Sender: TObject);
    procedure Enregisterlapartie1Click(Sender: TObject);
    procedure Tornade1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure AjouterpionbiClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Mode1Click(Sender: TObject);
    procedure Aimanthaut1Click(Sender: TObject);
    procedure RecommencerClick(Sender: TObject);
    procedure ImagePlateauClick(Sender: TObject);
    procedure SortirClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImagePlateauMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    AppliOnMessage:TMessageEvent;
    ColDiagonales:array of integer;
    RowDiagonales:array of integer;
    LastX:integer;
    LastY:integer;
    boolmoveForm:boolean;
    gagnant:integer;
    movepionsound:tstream;
    procedure TesteSerie(Col, row: string);
    procedure MoveToPionAJouer(Colonne, Ligne:integer);
    function ChercheCelluleLibre(var Colonne, Ligne: integer):boolean;
    procedure ConvertXY2CL(var X, Y: integer);

    procedure Rejouer;
  public
    JoueurAJouer:integer;
    PionAJouer:TPion;
    procedure NouveauPion(joueur:integer);
    procedure TesteGagnant;
  end;

var
  FrmRacine4: TFrmRacine4;

implementation


{$R *.dfm}

{ TRacine4 }


procedure TFrmRacine4.Aimanthaut1Click(Sender: TObject);
begin
  //gestion du basculement du mode aimant choisit
  aimanthaut1.checked:=Sender=Aimanthaut1;
  aimantgauche1.checked:=Sender=Aimantgauche1;
  aimantbas1.checked:=Sender=Aimantbas1;
  aimantdroit1.checked:=Sender=Aimantdroit1;
  //gestion de l'affichage de l'aimant choisit
  aimanthaut.Visible:=aimanthaut1.checked;
  aimantgauche.Visible:=aimantgauche1.checked;
  aimantbas.Visible:=aimantbas1.checked;
  aimantdroit.Visible:=aimantdroit1.checked;

  rejouer;
end;

procedure TFrmRacine4.AjouterpionbiClick(Sender: TObject);
begin
  Ajouterpionbi.Checked:=not  Ajouterpionbi.Checked;
  Rejouer;
end;

procedure TFrmRacine4.FormCreate(Sender: TObject);
begin
  //chargement des images
  ImagePlateau.Picture.LoadFromFile(extractfilepath(application.exename)+'images\Plateau.bmp');
  aimanthaut.Picture.LoadFromFile(extractfilepath(application.exename)+'images\Hmagnet.bmp');
  aimantgauche.Picture.LoadFromFile(extractfilepath(application.exename)+'images\Gmagnet.bmp');
  aimantbas.Picture.LoadFromFile(extractfilepath(application.exename)+'images\Bmagnet.bmp');
  aimantdroit.Picture.LoadFromFile(extractfilepath(application.exename)+'images\Dmagnet.bmp');

  JoueurAJouer:=1;
  NouveauPion(JoueurAJouer);
end;

procedure TFrmRacine4.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  imagePlateau.OnMouseMove(Sender,Shift,X-imagePlateau.left,Y-imagePlateau.Top);
end;

procedure TFrmRacine4.ConvertXY2CL(var X,Y:integer); //conversion de coordonnes X Y en ligne colonne
var
   calcul:extended;
begin
    calcul:=(X-134+38+23) / 70;  //idem qu'un ceil  colonne:=1+ceil((X-134+38+23) / 70);
    X := Integer(Trunc(calcul));
    if Frac(calcul) > 0 then
      Inc(X);
    X:=1+X;

    calcul:=(y-134+38+23) / 70; //idem qu'un ceil  colonne:=1+ceil((X-134+38+23) / 70);
    Y := Integer(Trunc(calcul));
    if Frac(calcul) > 0 then
      Inc(Y);
    Y:=1+Y;
end;


procedure TFrmRacine4.Enregisterlapartie1Click(Sender: TObject);
var
  F: TextFile;
  x, y: Integer;
begin
  if not SaveDialog1.Execute then exit;
  AssignFile(F, SaveDialog1.FileName);
  Rewrite(F);
  Writeln(F, JoueurAJouer);
  Writeln(F, Plateau.ColCount);
  Writeln(F, Plateau.RowCount);
  for x:=0 to Plateau.ColCount-1 do
    for y:=0 to Plateau.RowCount-1 do
      Writeln(F, Plateau.Cells[x,y]);
  CloseFile(F);
end;

procedure TFrmRacine4.Chargerunepartie1Click(Sender: TObject);
var
  F: TextFile;
  Tmp, x, y: Integer;
  TmpStr: string;
begin
  if not OpenDialog1.Execute then exit;
  Rejouer;
  AssignFile(F, OpenDialog1.FileName);
  Reset(F);
  Readln(F, Tmp);
  JoueurAJouer:=Tmp;
  PionAJouer.free;
  Readln(F, Tmp);
  plateau.ColCount:=Tmp;
  Readln(F, Tmp);
  plateau.RowCount:=Tmp;
  for x:=0 to plateau.ColCount-1 do
    for y:=0 to plateau.RowCount-1 do
    begin
      Readln(F, TmpStr);
      plateau.Cells[x,y]:=TmpStr;
      if tmpstr<>'' then
      begin
        NouveauPion(strtoint(TmpStr));
        PionAJouer.Colonne:=X+1;
        PionAJouer.Ligne:=Y+1;
        plateau.Objects[x,y]:=PionAJouer;
        PionAJouer.visible:=true;
      end;
    end;
  CloseFile(F);
  NouveauPion(JoueurAJouer);
end;


function TFrmRacine4.ChercheCelluleLibre(var Colonne,Ligne:integer):boolean; //conversion de coordonnes X Y en ligne colonne
begin
  result:=true;
  if aimanthaut1.Checked then //recheche d'une cellule vide depuis le bas
  begin
    Ligne:=7;
    while  (Ligne<>0)
    and    (Plateau.Cells[colonne-1,Ligne-1]<>'1')
    and    (Plateau.Cells[colonne-1,Ligne-1]<>'2')
    and    (Plateau.Cells[colonne-1,Ligne-1]<>'3')
    do
     dec(Ligne);
    inc(Ligne);
  end;
  if aimantbas1.Checked then //recheche d'une cellule vide depuis le haut
  begin
    Ligne:=1;
    while  (Ligne<>7)
    and    (Plateau.Cells[colonne-1,Ligne-1]<>'1')
    and    (Plateau.Cells[colonne-1,Ligne-1]<>'2')
    and    (Plateau.Cells[colonne-1,Ligne-1]<>'3')
    do
     inc(Ligne);
    dec(Ligne);
  end;
  if aimantgauche1.Checked then //recheche d'une cellule vide depuis la droite
  begin
    Colonne:=8;
    while  (Colonne<>0)
    and    (Plateau.Cells[colonne-1,Ligne-1]<>'1')
    and    (Plateau.Cells[colonne-1,Ligne-1]<>'2')
    and    (Plateau.Cells[colonne-1,Ligne-1]<>'3')
    do
     dec(Colonne);
    inc(Colonne);
  end;
  if aimantdroit1.Checked then //recheche d'une cellule vide depuis la gauche
  begin
    Colonne:=1;
    while  (Colonne<>8)
    and    (Plateau.Cells[colonne-1,Ligne-1]<>'1')
    and    (Plateau.Cells[colonne-1,Ligne-1]<>'2')
    and    (Plateau.Cells[colonne-1,Ligne-1]<>'3')
    do
     inc(Colonne);
    dec(Colonne);
  end;

  if (Colonne=0) or (Ligne=0)
  or (Colonne=8) or (Ligne=7)   then  //si pas de place et donc dehors
    result:=false;
end;


procedure TFrmRacine4.MoveToPionAJouer(Colonne,Ligne:integer);
var i:integer;
begin
  if aimanthaut1.Checked then
  begin
    PionAJouer.Colonne:=Colonne;
    for i := 6 downto Ligne do
    begin
      sleep(50);
      PionAJouer.Ligne:=i;
      PionAJouer.Image.Refresh;
    end;
  end;
  if aimantbas1.Checked then
  begin
    PionAJouer.Colonne:=Colonne;
    for i := 1 to Ligne do
    begin
      sleep(50);
      PionAJouer.Ligne:=i;
      PionAJouer.Image.Refresh;
    end;
  end;
  if aimantgauche1.Checked then
  begin
    PionAJouer.Ligne:=Ligne;
    for i := 7 downto Colonne do
    begin
      sleep(50);
      PionAJouer.Colonne:=i;
      PionAJouer.Image.Refresh;
    end;
  end;
  if aimantdroit1.Checked then
  begin
    PionAJouer.Ligne:=Ligne;
    for i := 1 to Colonne do
    begin
      sleep(50);
      PionAJouer.Colonne:=i;
      PionAJouer.Image.Refresh;
    end;
  end;
end;

procedure TFrmRacine4.ImagePlateauClick(Sender: TObject);
var index:integer;
    Colonne,Ligne:integer;
begin
  try
    if boolmoveForm then //si on vient de dplacer la form on sort
      exit;

//gestion du placement du pion
    Colonne:=LastX;
    Ligne:=LastY;
    ConvertXY2CL(Colonne,Ligne);//converti les coordonnes souris en Ligne colonne
    if not ChercheCelluleLibre(Colonne,Ligne) then //si il ne peux ramener le premire cellule libre
      exit;
    SplashScreen.playsound('coin08.wav',false);
    MoveToPionAJouer(Colonne,Ligne); //dplace le poin jusqu' la cellule libre
    //enregistre la position finale du pion
    Plateau.Cells[PionAJouer.Colonne-1,PionAJouer.ligne-1]:=inttostr(PionAJouer.Joueur);
    Plateau.Objects[PionAJouer.Colonne-1,PionAJouer.ligne-1]:=PionAJouer;

//changement de joueur
    if JoueurAjouer=1 then
    begin
      LbCountRouge.caption:=inttostr(strtoint(LbCountRouge.caption)-1);
      JoueurAjouer:=2;
    end
    else
    begin
      LbCountJaune.caption:=inttostr(strtoint(LbCountJaune.caption)-1);
      JoueurAjouer:=1;
    end;
    if Ajouterpionbi.checked then
    begin
      Randomize;
      if random(25)=5 then
      begin
        JoueurAjouer:=3;
        SplashScreen.playsound('boing5.wav',false);
      end;
    end;
    NouveauPion(JoueurAjouer);
    TesteGagnant;
 except
   JoueurAjouer:=JoueurAjouer;

 end;
end;

procedure TFrmRacine4.ImagePlateauMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var colonne, ligne:integer;
begin
  if shift=[ssLeft] then  //dtecte le click gauche enfonc
  begin
    Left:=Left+(X-LastX); //dplace la form en fonction du mouvement souris
    Top:=Top+(Y-LastY);   //par rapport  l'ancienne position souris
    boolmoveForm:=true;
    exit;
  end;
  boolmoveForm:=false;

  if PionAJouer<>nil then   //si on a un pion  jouer
  begin
    Colonne:=X;
    Ligne:=Y;
    ConvertXY2CL(Colonne,Ligne);//converti les coordonnes souris en Ligne colonne
    if aimanthaut1.Checked then
      ligne:=7;
    if aimantgauche1.Checked then
      Colonne:=8;
    if aimantbas1.Checked then
      ligne:=0;
    if aimantdroit1.Checked then
      Colonne:=0;
    if (PionAJouer.Colonne<>colonne)or(PionAJouer.ligne<>ligne) then
      SplashScreen.playsound('bottle.wav',false);
    PionAJouer.Colonne:=colonne;
    PionAJouer.Ligne:=Ligne;
    PionAJouer.visible:=true;
  end;

  //enregistre la position de la souris
  LastX:=X;
  LastY:=Y;
end;

procedure TFrmRacine4.Mode1Click(Sender: TObject);
begin
 mode2.Checked:=not  mode1.Checked;
 Rejouer;
end;

procedure TFrmRacine4.NouveauPion(joueur: integer);
begin
  PionAJouer:=TPion.Create;
  PionAJouer.Init(self,Joueur);
end;

procedure TFrmRacine4.SortirClick(Sender: TObject);
begin
 close;
end;

 procedure TFrmRacine4.TesteSerie(Col,row:string);
 var 
 chaine:string;
 k:integer;
 begin
   chaine:='';
   //cre la chaine  tester reprsentant un alignement
   for k := 1 to length(Col) do
   begin
    if plateau.Cells[strtoint(Col[k]),strtoint(Row[k])]<>'' then
      chaine:=chaine+plateau.Cells[strtoint(Col[k]),strtoint(Row[k])]
    else
      chaine:=chaine+'0';//rempli avec un 0 si vide a facilite le testwarning
   end;
   //test gagnant mode normal
   if pos('1111',chaine)>0 then
      gagnant:=1;
   if pos('2222',chaine)>0 then
      gagnant:=2;
   //teste avec pion bi
   if (pos('3111',chaine)>0)
   or (pos('1311',chaine)>0)
   or (pos('1131',chaine)>0)
   or (pos('1113',chaine)>0)
    then
    gagnant:=1;
   if (pos('3222',chaine)>0)
   or (pos('2322',chaine)>0)
   or (pos('2232',chaine)>0)
   or (pos('2223',chaine)>0)
    then
    gagnant:=2;

  //test warning si 3 pions aligns
  if Signal3pionsaligns.checked then
  begin
   if (pos('1110',chaine)>0) or (pos('0111',chaine)>0) or (pos('1011',chaine)>0)  or (pos('1101',chaine)>0)
   or (pos('2220',chaine)>0) or (pos('0222',chaine)>0) or (pos('2022',chaine)>0)  or (pos('2202',chaine)>0)
   or (pos('3110',chaine)>0) or (pos('0311',chaine)>0) or (pos('3011',chaine)>0)  or (pos('3101',chaine)>0)
   or (pos('1310',chaine)>0) or (pos('0131',chaine)>0) or (pos('1031',chaine)>0)  or (pos('1301',chaine)>0)
   or (pos('1130',chaine)>0) or (pos('0113',chaine)>0) or (pos('1013',chaine)>0)  or (pos('1103',chaine)>0)
   or (pos('3220',chaine)>0) or (pos('0322',chaine)>0) or (pos('3022',chaine)>0)  or (pos('3202',chaine)>0)
   or (pos('2320',chaine)>0) or (pos('0232',chaine)>0) or (pos('2032',chaine)>0)  or (pos('2302',chaine)>0)
   or (pos('2230',chaine)>0) or (pos('0223',chaine)>0) or (pos('2023',chaine)>0)  or (pos('2203',chaine)>0)
   then
     SplashScreen.playsound('munderattk.wav',true);
  end;
 end;


procedure TFrmRacine4.TesteGagnant;
begin
  gagnant:=0;
  //test sur les colonnes
  Testeserie('000000','012345');
  Testeserie('111111','012345');
  Testeserie('222222','012345');
  Testeserie('333333','012345');
  Testeserie('444444','012345');
  Testeserie('555555','012345');
  Testeserie('666666','012345');

  //test sur les lignes
  Testeserie('0123456','0000000');Testeserie('0123456','1111111');Testeserie('0123456','2222222');
  Testeserie('0123456','3333333');Testeserie('0123456','4444444');Testeserie('0123456','5555555');

  //test sur les diagonales
  Testeserie('3456','0123');
    Testeserie('23456','01234');
      Testeserie('123456','012345');
        Testeserie('012345','012345');
          Testeserie('01234','12345');
            Testeserie('0123','2345');
            Testeserie('0123','3210'  );
          Testeserie('01234','43210' );
        Testeserie('012345','543210');
      Testeserie('123456','543210');
    Testeserie('23456','54321' );
  Testeserie('3456','5432'  );

  //affichage rsultat
  if gagnant>0 then
  begin
    SplashScreen.playsound('Applaus.wav',false);
    if mode1.Checked  then
      showmessage('Joueur '+inttostr(gagnant)+'  gagn')
    else
      showmessage('Joueur '+inttostr(gagnant)+'  perdu');
    Rejouer;
  end;
  if ((LbCountRouge.caption='0')and(LbCountJaune.caption='0'))  //si plus de pions  jouer
  or (  length(plateau.Rows[0].text+plateau.Rows[5].text   //si tout les contours pleins cas si mode tornade
              +plateau.cols[0].text+plateau.cols[6].text)
              =28
     )
  then
  begin
    SplashScreen.playsound('cri.wav',false);
    showmessage('Partie nulle');
    Rejouer;
  end;
end;


procedure TFrmRacine4.Timer1Timer(Sender: TObject);
var sens:integer;
  aeventproc:TNotifyEvent;
begin
  if Lbhaut.caption='0' then
  begin
    //inhibe le click sur le plateau
    aeventproc:=ImagePlateau.OnClick;
    ImagePlateau.OnClick:=nil;
    //joue le son avertisseur
    SplashScreen.playsound('FX.WAV',true);
    //gestion alatoire de la position de l'aimant
    Randomize;
    sens:=random(4)+1;
    //gestion de l'affichage de l'aimant
    aimanthaut.Visible:=sens=1;
    aimantgauche.Visible:=sens=2;
    aimantbas.Visible:=sens=3;
    aimantdroit.Visible:=sens=4;
    //raz du timer
    Lbhaut.caption:='21';
    //on fait tomber le pion en cours sinon c'est pas marrant
    application.ProcessMessages;
    ImagePlateau.OnClick:=aeventproc;
    ImagePlateau.OnClick(self);
  end;

  //gestion des coches dans le menu
  aimanthaut1.checked   :=aimanthaut.Visible;
  aimantgauche1.checked :=aimantgauche.Visible;
  aimantbas1.checked    :=aimantbas.Visible;
  aimantdroit1.checked  :=aimantdroit.Visible;

  //gestion de l'affichage du temps
  Lbhaut.Visible:=Aimanthaut1.Checked;
  Lbgauche.Visible:=Aimantgauche1.Checked;
  Lbbas.Visible:=Aimantbas1.Checked;
  Lbdroit.Visible:=Aimantdroit1.Checked;

  //gestion du timer
  Lbhaut.caption:=inttostr(strtoint(Lbhaut.caption)-1);
  Lbgauche.caption:=Lbhaut.caption;
  Lbbas.caption:=Lbhaut.caption;
  Lbdroit.caption:=Lbhaut.caption;
end;


procedure TFrmRacine4.Tornade1Click(Sender: TObject);
begin
  timer1.Enabled:=Tornade1.Checked;
end;


procedure TFrmRacine4.RecommencerClick(Sender: TObject);
begin
 rejouer;
end;

procedure TFrmRacine4.Rejouer;
var
  i,j: Integer;
begin
  //vide le plateau
  for i := 0 to plateau.ColCount - 1 do
    for j := 0 to plateau.RowCount - 1 do
    begin
      plateau.Cells[i, j] := '0';
      if plateau.Objects[i, j] <> nil then
      begin
        Tpion(plateau.Objects[i, j]).free;
        plateau.Objects[i, j] := nil;
      end;
    end;
  imagePlateau.Refresh;
  LbCountRouge.caption:='21';
  LbCountJaune.caption:='21';
end;

end.
